//
//  PasswordLoginView.m
//  Luba
//
//  Created by 张浩 on 2018/4/27.
//  Copyright © 2018年 sjl. All rights reserved.
//

#import "PasswordLoginView.h"
#import "login_common.h"

@interface PasswordLoginView()
@property (nonatomic , strong)UIView *phoneView;
@property (nonatomic , strong)UIView *pwdView;
@end
@implementation PasswordLoginView
-(instancetype)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    if (self) {
        self.backgroundColor = [UIColor whiteColor];
        [self addSubview:self.phoneView];
        [self addSubview:self.pwdView];
        [self addSubview:self.changeBtn];
        [self.phoneView addSubview:self.phoneTF];
        UIView *line1 = [[UIView alloc]init];
        line1.backgroundColor = [UIColor groupTableViewBackgroundColor];
        [self.phoneView addSubview:line1];
        
        [self.pwdView addSubview:self.pwdTF];
        [self.pwdView addSubview:self.forgetPwdBtn];
        UIView *line2 = [[UIView alloc]init];
        line2.backgroundColor = [UIColor groupTableViewBackgroundColor];
        [self.pwdView addSubview:line2];
        
        [self.phoneView mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.top.right.equalTo(self);
            make.height.equalTo(@60);
        }];
        [self.phoneTF mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(self.phoneView.mas_left).offset(30);
            make.right.equalTo(self.phoneView.mas_right).offset(-30);
            make.centerY.equalTo(self.phoneView.mas_centerY);
            make.height.equalTo(@30);
        }];
        [line1 mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(self.phoneView.mas_left).offset(30);
            make.right.equalTo(self.phoneView.mas_right).offset(-30);              make.bottom.equalTo(self.phoneView.mas_bottom).offset(-1);
            make.height.equalTo(@1);
        }];
        
        [self.pwdView mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.right.equalTo(self);
            make.top.equalTo(self.phoneView.mas_bottom);
            make.height.equalTo(@60);
        }];
        [self.pwdTF mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(self.pwdView.mas_left).offset(30);
            make.right.equalTo(self.forgetPwdBtn.mas_left).offset(-10);
            make.centerY.equalTo(self.pwdView.mas_centerY);
            make.height.equalTo(@30);
        }];
        [self.forgetPwdBtn mas_makeConstraints:^(MASConstraintMaker *make) {
            make.right.equalTo(self.pwdView.mas_right).offset(-30);
            make.centerY.equalTo(self.pwdView.mas_centerY);
            make.height.equalTo(@30);
            make.width.equalTo(@80);
        }];
        [line2 mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(self.pwdView.mas_left).offset(30);
            make.right.equalTo(self.pwdView.mas_right).offset(-30);             make.bottom.equalTo(self.pwdView.mas_bottom).offset(-1);
            make.height.equalTo(@1);
        }];
        [self.changeBtn mas_makeConstraints:^(MASConstraintMaker *make) {
            make.right.equalTo(self.mas_right).offset(-30);
            make.top.equalTo(self.pwdView.mas_bottom).offset(5);
            make.height.equalTo(@30);
            make.width.equalTo(@70);
        }];
    }
    return self;
}
- (void)countTextLength:(UITextField *)textField {
    if (textField.text.length >11) {
        [MBManager showBriefAlert:@"手机号长度超出"];
        textField.text = [textField.text substringToIndex:11];
    }
}
-(UIView *)phoneView{
    if (_phoneView == nil) {
        _phoneView = [[UIView alloc]init];
        _phoneView.backgroundColor = [UIColor whiteColor];
    }
    return _phoneView;
}
-(UIView *)pwdView{
    if (_pwdView == nil) {
        _pwdView = [[UIView alloc]init];
        _pwdView.backgroundColor = [UIColor whiteColor];
    }
    return _pwdView;
}
-(UITextField *)phoneTF{
    if (_phoneTF == nil) {
        _phoneTF = [[UITextField alloc]init];
        _phoneTF.textColor = [UIColor colorWithHexString:@"#333333"];
        _phoneTF.font = [UIFont systemFontOfSize:25];
        _phoneTF.placeholder = @"手机号";
        [_phoneTF setValue:[UIColor colorWithHexString:@"#C3C3C3"] forKeyPath:@"_placeholderLabel.textColor"];
        [_phoneTF addTarget:self action:@selector(countTextLength:) forControlEvents:UIControlEventEditingChanged];
        _phoneTF.keyboardType = UIKeyboardTypePhonePad;
    }
    return _phoneTF;
}
-(UITextField *)pwdTF{
    if (_pwdTF == nil) {
        _pwdTF = [[UITextField alloc]init];
        _pwdTF.textColor = [UIColor colorWithHexString:@"#333333"];
        _pwdTF.font = [UIFont systemFontOfSize:25];
        _pwdTF.placeholder = @"输入密码";
        [_pwdTF setValue:[UIColor colorWithHexString:@"#C3C3C3"] forKeyPath:@"_placeholderLabel.textColor"];
        [_pwdTF setSecureTextEntry:YES];
    }
    return _pwdTF;
}
-(UIButton *)changeBtn{
    if (_changeBtn == nil) {
        _changeBtn = [[UIButton alloc]init];
        [_changeBtn setTitleColor:[UIColor colorWithHexString:@"#16A196"] forState:UIControlStateNormal];
        _changeBtn.titleLabel.font = [UIFont systemFontOfSize:12];
        [_changeBtn setTitle:@"验证码登录" forState:UIControlStateNormal];
        _changeBtn.contentHorizontalAlignment = UIControlContentHorizontalAlignmentRight;
    }
    return _changeBtn;
}
-(UIButton *)forgetPwdBtn{
    if (_forgetPwdBtn == nil) {
        _forgetPwdBtn = [[UIButton alloc]init];
        [_forgetPwdBtn setTitle:@"忘记密码？" forState:UIControlStateNormal];
        [_forgetPwdBtn setTitleColor:[UIColor colorWithHexString:@"#16A196"] forState:UIControlStateNormal];
        _forgetPwdBtn.titleLabel.font = [UIFont systemFontOfSize:12];
        _forgetPwdBtn.contentHorizontalAlignment = UIControlContentHorizontalAlignmentRight;
    }
    return _forgetPwdBtn;
}
@end
